/* Teil von RandomXmas v1.1 zu Weihnachten 2001 
 * Frei kopierbar, aber nur vollstndig mit diesem Spiel.c und Makefile und 
 * readme.txt. Vernderungen mglich, bei Weitergabe aber immer Original 
 * hiervon und Spiel.c mit beilegen,		
 * Keine Patentierungen auf Teile des oder ganzes Programm(s)*/

#include "konstanten.h"
#include "grafikausg.h"

#ifndef EBENENFELD_H
#define EBENENFELD_H 1

typedef enum{typlos, baum, huegel} feldtyp;

class Feld
  {	public:
		Feld(feldtyp neutyp, int neuhoehe, int neudarunter, int neudarueber);
		~Feld();
		void     Change(feldtyp neutyp, int neuhoehe,
				 int neudarunter);
		int      Leeren();
		int 	 GetDarueber();
                feldtyp  GetTyp();
		void 	 DrawFeld(int x, int y);
		char 	 textoben[2];
	private:
		GLUquadric *qfeld;
		feldtyp typ;
		int darunter;
		GrafikAusgabe *darueber;
		int hoehe;
  };

class Ebene
  {	public:
		Ebene(int neunummer);
		~Ebene();
                int  IstDortBaum(int x, int y);
		int  GetDarueber(int x, int y);
		void TrigFahrstuhl();
		void DrawEbene();
	private:
		Feld *felder[MAXFELD][MAXFELD];
		int fahrstuhl;
		GrafikAusgabe *nummer, *zeile;
  };

typedef struct 
   { 
	Ebene *spielraum[MAXEBENEN-2];
	short raumused[MAXEBENEN-2];
	int   aktebene, punkte, ende;
   } Spielraumtyp;

#endif

