/* Teil von RandomXmas v1.1 zu Weihnachten 2001 
 * Frei kopierbar, aber nur vollstndig mit diesem Spiel.c und Makefile und 
 * readme.txt. Vernderungen mglich, bei Weitergabe aber immer Original
 * hiervon und Spiel.c mit beilegen,		
 * Keine Patentierungen auf Teile des oder ganzes Programm(s)*/

#include <GL/glut.h>
#include "konstanten.h"
#include "geschenke.h"

//---Klasse Geschenke-----------------------------

Geschenke::Geschenke(int kanzfertig, int ganzfertig)
{
  this->kanz = new GrafikAusgabe(-MAXFELD*2, MAXFELD*3, 0);
  this->kanz->SetSize(MAXFELD/3);
  this->kanz->SetColor(1.0, 1.0, 0.0);
  this->kfertig = new GrafikAusgabe(-MAXFELD, MAXFELD*3, 0, kanzfertig);
  this->kfertig->SetSize(MAXFELD/3);
  this->kfertig->SetColor(0.75, 0.75, 0.0);
  this->ganz = new GrafikAusgabe(-MAXFELD*2, MAXFELD*5/2, 0);
  this->ganz->SetSize(MAXFELD/3);
  this->ganz->SetColor(0.0, 1.0, 1.0);
  this->gfertig = new GrafikAusgabe(-MAXFELD, MAXFELD*5/2, 0, ganzfertig);
  this->gfertig->SetSize(MAXFELD/3);
  this->gfertig->SetColor(0.0, 0.75, 0.75);

  this->punktanz = 1;
}

Geschenke::~Geschenke()
{
  delete this->kanz; 
  delete this->ganz;
  delete this->kfertig;
  delete this->gfertig;
}

void Geschenke::AddAnz(int mult, int kplus, int gplus)
{
  if (mult == 0) mult = 10;
  if (kplus > 0) this->kanz->AddWert(kplus);
  if (gplus > 0) this->ganz->AddWert(gplus);
  if ((kplus == 9) & (gplus == 9))
    {
	kanz->SetWert( kanz->GetWert() * 2 );
	ganz->SetWert( ganz->GetWert() * 2 );
    }
  kfertig->SetWert( kfertig->GetWert() * mult / 10);
  gfertig->SetWert( gfertig->GetWert() * mult / 10);
}

int Geschenke::Fertig()
{
  int erg=0;
  
  if ((kanz->GetWert() >= kfertig->GetWert() ) && (ganz->GetWert() >= gfertig->GetWert())) erg = 1;
  return erg;
};

int Geschenke::Punkte()
{
  int erg;
  
  erg = ganz->GetWert() *100 + kanz->GetWert();
  return erg;
}

void Geschenke::DrawGeschenke()
{
  if (punktanz)
    {
	kanz->DrawAusgabe();
	kfertig->DrawAusgabe();
	ganz->DrawAusgabe();
	gfertig->DrawAusgabe();
    }
}

