/* Teil von RandomXmas v1.1 zu Weihnachten 2001 
 * Frei kopierbar, aber nur vollstndig mit diesem Spiel.c und Makefile und 
 * readme.txt. Vernderungen mglich, bei Weitergabe aber immer Original
 * hiervon und Spiel.c mit beilegen,		
 * Keine Patentierungen auf Teile des oder ganzes Programm(s)*/

#include <GL/glut.h>
#include <ctype.h>
#include "grafikausg.h"

//---Klasse GrafikAusgabe-------------------------

void GrafikAusgabe::DrawAusgabe()
{
  GLfloat ausg_amb[] = {red, green, blue};

  short ziffer[10], i, j, last, maxstellen;
  unsigned int bild, poswert, zwwert;
  unsigned int char_zu_lcd[64]; //ASCII-Code 32-95
  unsigned int zif_zu_lcd[10];  // Punkte  0x123AC980 -> von 1 nach 2,3,10,12,9,8,0  
  				//	  .  .  .  1 2 3    0=Unterbrechung
				//	  .  .  .  4 5 6		
				//	  .  .  .  7 8 9
				//	  .  .  .  A B C
				//	  .  .  .  D E F
  
  zif_zu_lcd[0]=0x13FD1000; zif_zu_lcd[1]=0x3F000000; zif_zu_lcd[2]=0x1397DF00;	
  zif_zu_lcd[3]=0x13979FD0; zif_zu_lcd[4]=0x17939F00; zif_zu_lcd[5]=0x3179FD00;			
  zif_zu_lcd[6]=0x3179FD70; zif_zu_lcd[7]=0x13F00000; zif_zu_lcd[8]=0x71397DF9;			
  zif_zu_lcd[9]=0x9713FD00;
   char_zu_lcd[0]=0xF0000000;  char_zu_lcd[1]=0x82380EF0;  char_zu_lcd[2]=0x14036000; //  !"
   char_zu_lcd[3]=0x5E0AC097;  char_zu_lcd[4]=0x3179FDE2;  char_zu_lcd[5]=0x2713DF9E; // #$%
   char_zu_lcd[6]=0x9EA324F0;  char_zu_lcd[7]=0x36800000;  char_zu_lcd[8]=0x24AE0000; // &'(
   char_zu_lcd[9]=0x26CE0000; char_zu_lcd[10]=0x4C06A000; char_zu_lcd[11]=0x5B079000; // )*+
  char_zu_lcd[12]=0x9CE00000; char_zu_lcd[13]=0x79000000; char_zu_lcd[14]=0xEF000000; // ,-.
  char_zu_lcd[15]=0xD3000000; char_zu_lcd[16]=zif_zu_lcd[0]; char_zu_lcd[17]=zif_zu_lcd[1];    // /01
  char_zu_lcd[18]=zif_zu_lcd[2]; char_zu_lcd[19]=zif_zu_lcd[3]; char_zu_lcd[20]=zif_zu_lcd[4]; // 234
  char_zu_lcd[21]=zif_zu_lcd[5]; char_zu_lcd[22]=zif_zu_lcd[6]; char_zu_lcd[23]=zif_zu_lcd[7]; // 567
  char_zu_lcd[24]=zif_zu_lcd[8]; char_zu_lcd[25]=zif_zu_lcd[9]; char_zu_lcd[26]=0x250BE000;    // 89:	
  char_zu_lcd[27]=0x560CE000; char_zu_lcd[28]=0x67C00000; char_zu_lcd[29]=0x460AC000; // ;<=
  char_zu_lcd[30]=0x49A00000; char_zu_lcd[31]=0x4139B0EF; char_zu_lcd[32]=0x98BC64DF; // >?@
  char_zu_lcd[33]=0xD72979F0; char_zu_lcd[34]=0x167CD100; char_zu_lcd[35]=0x34AF0000; // ABC
  char_zu_lcd[36]=0x16CD1000; char_zu_lcd[37]=0x31787DF0; char_zu_lcd[38]=0x31787D00; // DEF
  char_zu_lcd[39]=0x34AF9800; char_zu_lcd[40]=0x1D793F00; char_zu_lcd[41]=0x132EDF00; // GHI
  char_zu_lcd[42]=0x13CEA000; char_zu_lcd[43]=0x1D737F00; char_zu_lcd[44]=0x1DF00000; // JKL
  char_zu_lcd[45]=0xD183F000; char_zu_lcd[46]=0xD1F30000; char_zu_lcd[47]=0x24AEC620; // MNO
  char_zu_lcd[48]=0xD1670000; char_zu_lcd[49]=0xC624AEF8; char_zu_lcd[50]=0xD167F000; // PQR
  char_zu_lcd[51]=0x32478CED; char_zu_lcd[52]=0x132E0000; char_zu_lcd[53]=0x1DF30000; // STU
  char_zu_lcd[54]=0x1E300000; char_zu_lcd[55]=0x1D8F3000; char_zu_lcd[56]=0x1F03D000; // VWX
  char_zu_lcd[57]=0x1838E000; char_zu_lcd[58]=0x13DF0000; char_zu_lcd[59]=0x21DE0000; // YZ[
  char_zu_lcd[60]=0xF1000000; char_zu_lcd[61]=0x23FE0000; char_zu_lcd[62]=0x42600000; // \]^
  char_zu_lcd[63]=0xDF000000; // _

  glPushMatrix();
  glTranslatef(posx, posy, posz);

  poswert = 1000 * 1000 * 1000;
  zwwert = wert; 
  maxstellen = 10;
  if (!alpha)
    {
      last = 0;
      for(i=9; i>=0; i--)
       {
	if ( !(ziffer[i] = (zwwert / poswert)) && (last == 0) ) maxstellen--;
	  else last = 1;
	zwwert = zwwert % poswert;
	poswert = poswert / 10;
       } 
      if (maxstellen == 0) maxstellen = 1;
    }
   else maxstellen = strlen(text);

  glColor3f(red, green, blue);
  glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, ausg_amb);
  for(i=maxstellen-1; i>=0; i--)
    { 
	if (alpha) 
	  {
		if (text) zwwert = toupper( text[maxstellen-i-1] );
		  else zwwert = 32;
		if ((zwwert >= 32) && (zwwert <= 95)) zwwert = (zwwert - 32) % 64;
		 else zwwert = 0;	//nicht darstellbare Zeichen auf ' '
		bild = char_zu_lcd[ zwwert ];
	  }
	 else bild = zif_zu_lcd[ ziffer[i] ];
	poswert = 0xF0000000;
	last = 0;
	for(j=0; j<=15; j++)
	  {
		zwwert = (bild & poswert);
		while (zwwert > 15) zwwert = zwwert >> 4;
		if ((last == 0) && (zwwert > 0)) glBegin(GL_LINE_STRIP);
		if (zwwert == 1) 		   glVertex2f(     0, 0);
		if (zwwert == 2) 		   glVertex2f(size/4, 0);
		if (zwwert == 3) 		   glVertex2f(size/2, 0);
		if (zwwert == 4) 		   glVertex2f(     0, -size/4);
		if (zwwert == 5) 		   glVertex2f(size/4, -size/4);
		if (zwwert == 6) 		   glVertex2f(size/2, -size/4);
		if (zwwert == 7) 		   glVertex2f(     0, -size/2);
		if (zwwert == 8) 		   glVertex2f(size/4, -size/2);
		if (zwwert == 9) 	 	   glVertex2f(size/2, -size/2);
		if (zwwert == 0xA) 		   glVertex2f(     0, -3*size/4);
		if (zwwert == 0xB) 		   glVertex2f(size/4, -3*size/4);
		if (zwwert == 0xC) 		   glVertex2f(size/2, -3*size/4);
		if (zwwert == 0xD) 		   glVertex2f(     0, -size);
		if (zwwert == 0xE) 		   glVertex2f(size/4, -size);
		if (zwwert == 0xF) 		   glVertex2f(size/2, -size);
		if ((last > 0) && (zwwert == 0)) glEnd();
		if (j == 7) 
		  {	
			if (zwwert > 0) glEnd(); 
			glTranslatef(size/32, size/32, 0);
			glBegin(GL_LINE_STRIP);
		  }
		last = zwwert;
		if (j < 7) poswert = poswert >> 4;
		if ((j >= 8) && (j < 15)) poswert = poswert << 4;
		if (j == 15) 
		  {
			if (zwwert > 0) glEnd();
			glTranslatef(-size/32, -size/32, 0);
		  };
	  }
	glTranslatef(3*size/4, 0, 0);
    }
  glPopMatrix();
}

