/* Teil von RandomXmas v1.1 zu Weihnachten 2001 
 * Frei kopierbar, aber nur vollstndig mit diesem Spiel.c und Makefile und 
 * readme.txt. Vernderungen mglich, bei Weitergabe aber immer Original 
 * hiervon und Spiel.c mit beilegen,		
 * Keine Patentierungen auf Teile des oder ganzes Programm(s)*/

#include <GL/glut.h>
#include <stdlib.h>
#include "mann.h"

//---Klasse Mann----------------------------------

Mann::Mann(float neugroesse, float neubreite)
{
  this->groesse = neugroesse;
  this->breite = neubreite;
  this->posx = MAXFELD;
  this->posy = MAXFELD;
  this->jump = 0;
  this->schenken = new Geschenke(ZUMGEWINN % 100, ZUMGEWINN/100);
  qmann = gluNewQuadric();
};

Mann::~Mann()
{
  delete schenken;
  gluDeleteQuadric(qmann);
};

void Mann::Fahrstuhl(Spielraumtyp *spraum, int neuebene)
{
  int zufall, altebene;

  if (schenken->Fertig() == 1) neuebene = MAXEBENEN-1;
  if (neuebene > 0)				//Sonst kein Fahrstuhl da
    {
	zufall = rand() % CHVERLIEREN;
	if (schenken->Fertig() == 1) neuebene = MAXEBENEN-1;
	  else if (zufall == 0) neuebene = 0;		//Pech gehabt
 	if (spraum->aktebene == neuebene) 
          if (spraum->aktebene+1 < MAXEBENEN) neuebene++;
	    else neuebene--;
        if ((neuebene > 0) && (neuebene < MAXEBENEN-1))
	  {
		this->posx = MAXFELD;			//Vorbereiten
		this->posy = MAXFELD;
		spraum->spielraum[spraum->aktebene-1]->TrigFahrstuhl();
		if (!(spraum->raumused[neuebene-1]))
		  {
		   	spraum->spielraum[neuebene-1] = 
						new Ebene(neuebene-1);
		  	spraum->raumused[neuebene-1] = 1;
		  }
		spraum->spielraum[neuebene-1]->TrigFahrstuhl();

		altebene = spraum->aktebene;		//Umschalten
		spraum->aktebene = neuebene;

		spraum->spielraum[altebene-1]->TrigFahrstuhl();	//Wiederherstellen
		spraum->spielraum[neuebene-1]->TrigFahrstuhl();		 
	  }
	if (neuebene ==  0) { spraum->punkte = -1; spraum->ende = 1; };
	if (neuebene == MAXEBENEN-1) 
	  { 
		spraum->punkte = schenken->Punkte(); 
		spraum->ende   = 1;
	  };
    }
};

void Mann::AddPos(Spielraumtyp *spraum, int x, int y, int j)
{
  int neuposx, neuposy, erg;

  switch (j)
    {		// Aufladen mit j=1, dann j=0 springen(jump=2), dann aus.
	case 0 : if (jump == 1) jump = 2; else jump = 0; break;
	case 1 : if (jump < 2 ) jump = 1; break;
    };
  neuposx = this->posx + x;
  neuposy = this->posy + y;
  if ((neuposx <= MAXFELD) && (neuposx >= -MAXFELD))
    {
	if (jump < 1)
	{
	  erg = spraum->spielraum[spraum->aktebene-1]->IstDortBaum(neuposx, neuposy);
	  if (erg <= -1) this->posx = neuposx;
          if (erg >=  0) schenken->AddAnz(erg/100, erg % 10, (erg % 100)/10 );
	  if (erg <= -2) this->Fahrstuhl( spraum, -((erg%100)+2) );
	}
	else { 
		this->posx = neuposx;
		erg = spraum->spielraum[spraum->aktebene-1]->GetDarueber(neuposx, neuposy);
		schenken->AddAnz(erg/100, erg % 10, (erg % 100)/10);
	     }
    }
  if ((neuposy <= MAXFELD) && (neuposy >= -MAXFELD))
    {
	if (jump < 1)
	{
	  erg = spraum->spielraum[spraum->aktebene-1]->IstDortBaum(neuposx, neuposy);
	  if (erg <= -1) this->posy = neuposy;
	  if (erg >=  0) schenken->AddAnz(erg/100, erg % 10, (erg % 100)/10 );
	  if (erg <= -2) this->Fahrstuhl( spraum, -(erg+2) );
	}
	else this->posy = neuposy;
    }
}

void Mann::NeuRichtung(int winkel)
{
  this->richtung = winkel;
}

void Mann::DrawMann()
{
  GLfloat mann_amb_black[] = {0, 0, 0}, mann_amb_red[] = {1.0, 0, 0};
  GLfloat mann_amb_orange[] = {1.0, 0.7, 0.7};

  glPushMatrix();
  if (jump == 2) glTranslatef(posx * 2, 10*FELDEINHEIT, posy * 2);
    else glTranslatef(this->posx * 2, 0, this->posy * 2);
  glRotatef(-90, 1, 0, 0);
  glRotatef(richtung, 0, 0, 1);

  glPushMatrix();
  glTranslatef(-(this->breite/2), this->breite/2, 0);
  glColor3f(0.0, 0.0, 0.0);
  glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, mann_amb_black);
  gluCylinder(qmann, this->breite/2, this->breite/2, this->groesse/10, 10, 5);
  glTranslatef(this->breite/2*2, 0, 0);
  gluCylinder(qmann, this->breite/2, this->breite/2, this->groesse/10, 10, 5);
  glPopMatrix();

  glPushMatrix();
  glColor3f(1.0, 0.0, 0.0);
  glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, mann_amb_red);
  glTranslatef(0, 0, this->groesse/10);
  gluCylinder(qmann, this->breite, this->breite/2, 7.5*(this->groesse)/10,
 		 10,5);
  glPopMatrix();

  glTranslatef(0, 0, 8.5*this->groesse/10);
  glColor3f(1.0, 0.7, 0.7);
  glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, mann_amb_orange);
  gluSphere(qmann, 1.2*this->groesse/10, 10, 10);
  glTranslatef(0, -this->groesse/20, this->groesse/20);
  glRotatef(45, 1, 0, 0);
  glColor3f(1.0, 0.0, 0.0);
  glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, mann_amb_red);
  gluCylinder(qmann, 1.4*this->groesse/10, 0,
		this->groesse/3, 10, 5);
  if (jump == 1) glTranslatef(0, -12*FELDEINHEIT, 0);
  glPopMatrix();
  schenken->DrawGeschenke();
}

